#include "dirpath.h"
#include "zxcc.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

static char cmdbuf[1024];

int fname_opt(char *arg, char c)
{
	if ((arg[1] == c || arg[1] == toupper(c)) && arg[2])
	{
		sprintf(cmdbuf + strlen(cmdbuf), "-%c +%s", c, arg + 2);
		strcat(cmdbuf," ");
		return 1;	
	}
	return 0;
}

int main(int argc, char **argv)
{	
	int n;
    printf("[BeOS] Z80 assembler by Marat Fayzullin\n       re-ported to BeOS by Devilcoder (www.webalice.it/devilcoder)\n");
	printf("       zxas=%s\n",z80tools_dirpath_zxas);

	strcpy(cmdbuf,z80tools_dirpath_zxas " ");
	for (n = 1; n < argc; n++)
	{
		if (argv[n][0] == '-')	/* An option */
		{
			strcat(cmdbuf,"-");

			/* The following options can take filenames */

			if (fname_opt(argv[n], 'o')) continue;
			if (fname_opt(argv[n], 'l')) continue;
		}
		strcat(cmdbuf,argv[n]);
		strcat(cmdbuf," ");
	}	
	return system(cmdbuf);
}
